#============================================================================================================================================#
# -*- coding:Utf-8 -*-
# sound_menu V1.1p (02/01/2008)
# MATTIE'S EVENTSCRIPTS 2.0, PYTHON OPERATIONNEL




import psyco
psyco.full()

import es, os, re, popuplib, playerlib, ConfigParser
from es import server_var
from FileAnalyse import FileAnalyse




#    Info    #
sm_info = es.AddonInfo()
sm_info.version = "1.0p"
sm_info.author = "DoCky"
sm_info.name = "sound_menu"
sm_info.url = "http://addons.eventscripts.com/addons/user/11751"
sm_path = os.getcwd().replace(os.sep, "/") + "/cstrike/cfg/sound_menu/"




#    Class    #
class SoundList:
    """
        Classe privé

            -créer une base de données avec les fichiers de configurations
    """

    def __init__(self):
        """
            Fonction: créer une liste de touts les fichiers de type "CFG"
        """

        self.__sm_down = []
        self.__sm_conf = ConfigParser.ConfigParser()

        sm_patt = re.compile(".*\.txt$").search
        sm_file = filter(sm_patt, os.listdir(sm_path + "sound"))

        for sm_type in sm_file:
            sm_file[sm_file.index(sm_type)] = os.path.splitext(sm_type)[0]

        self.__setConf(sm_file)


    def __setConf(self, cfgFile):
        """
            Fonction: analyse et enregistrement des informations dans une base de données
        """

        for sm_file in cfgFile:
            sm_read = FileAnalyse(sm_path + "sound/" + sm_file + ".txt").getList()

            if sm_read:
                self.__sm_conf.add_section(str(sm_file))

                for sm_conf in sm_read:
                    sm_spli = sm_conf.split("=")
                    self.__sm_down.append("sound/" + str(sm_spli[1].strip()))
                    self.__sm_conf.set(str(sm_file), str(sm_spli[0].strip()), str(sm_spli[1].strip()))


    def getDown(self):
        """
            Fonction: renvoie une liste de téléchargement
        """

        return self.__sm_down[:]


    def getConf(self):
        """
            Fonction: renvoie la configuration du script
        """

        return self.__sm_conf


class BuildMenu:
    """
        Classe privé

            -construit le menu selon son apparence désiré
    """

    def setLine(self, popupName, popupItem):
        """
            Fonction: créer les séparations du menu selon la configuration
        """

        for sm_sepa in str(popupItem).split(","):
            try:
                if int(sm_sepa):
                    sm_inds = 0
                    while sm_inds < int(sm_sepa):
                        sm_inds += 1
                        popupName.addline(" ")

            except:
                if str(sm_sepa):
                    popupName.addline(sm_sepa)


    def sepNumb(self, sepItem):
        """
            Fonction: obtenir le nombre de ligne a ajouté pour une séparation précise
        """

        sm_line = 0
        if sepItem != "0":
            for sm_item in str(sepItem).split(","):
                try:
                    if int(sm_item):

                        sm_inds = 0
                        while sm_inds < int(sm_item):
                            sm_line += 1
                            sm_inds += 1

                except:
                    sm_line += 1

        return sm_line


class SoundMenu:
    """
        Classe privé

            -créer un menu correspondant aux éléments de la base de données 
    """


    def smMake(self):
        """
            Fonction: créer les pages du menu selon les fichiers crées
        """

        self.__sm_pars = ConfigParser.ConfigParser()

        sm_list = SoundInfo.sm_list.getConf().sections()
        sm_list.sort()

        for sm_type in sm_list:
            sm_sons = SoundInfo.sm_list.getConf().options(sm_type)
            sm_sons.sort()
            self.__sons(sm_list, sm_type, sm_sons)

        self.__type(sm_list)
        self.__menu(sm_list)
        self.__team(sm_list)


    def __page(self, itemCount):
        """
            Fonction: déterminer le nombre de pages
        """

        if itemCount < 9:
            return 1

        else:
            sm_page = itemCount / 7
            sm_rest = itemCount % 7

            if sm_rest > 1:
                sm_page += 1

            return sm_page


    def __item(self, itemIndex, itemPages, itemCount):
        """
            Fonction: déterminer le nombre de choix
        """

        if itemIndex + 1 < itemPages:
            return 7

        else:
            return itemCount - ((itemIndex) * 7)


    def __menu(self, typeList):
        """
            Fonction: créer les pages du menu d'acceuil
        """

        sm_menu = popuplib.create("sm_menu")
        BuildMenu().setLine(sm_menu, server_var["sm_separ1"])
        sm_menu.addline(str(server_var["sm_tittle_menu"]))
        BuildMenu().setLine(sm_menu, server_var["sm_separ2"])
        sm_menu.addline("->1. %s" % str(server_var["sm_option_type"]))
        sm_menu.addline("->2. %s" % str(server_var["sm_option_user"]))
        sm_menu.addline("->3. %s" % str(server_var["sm_option_team"]))
        sm_menu.addline("->4. %s" % str(server_var["sm_option_stop"]))
        BuildMenu().setLine(sm_menu, server_var["sm_separ3"])
        sm_menu.addline("0. %s" % str(server_var["sm_action_exit"]))
        BuildMenu().setLine(sm_menu, server_var["sm_separ4"])

        if len(typeList) > 1:
            sm_menu.submenu(1, "sm_type_0")

        else:
            sm_menu.submenu(1, "sm_type_%s_0" % str(typeList[0]))

        sm_menu.submenu(3, "sm_team")

        if bool(SoundInfo.sm_stic):
            sm_menu.submenu(4, "sm_menu")

        sm_menu.menuselect = menu


    def __type(self, typeList):
        """
            Fonction: créer les pages du menu selon les types répertoriés
        """

        sm_page = self.__page(len(typeList))
        sm_indp = 0

        while sm_indp < sm_page:
            sm_indi = 0
            sm_name = "sm_type_%s" % str(sm_indp)
            sm_item = self.__item(sm_indp, sm_page, len(typeList))

            sm_crea = popuplib.create(sm_name)
            BuildMenu().setLine(sm_crea, server_var["sm_separ1"])
            sm_crea.addline("%s    %s/%s" % (str(server_var["sm_tittle_type"]), str(sm_indp + 1), str(sm_page)))
            BuildMenu().setLine(sm_crea, server_var["sm_separ2"])

            while sm_indi < sm_item:
                sm_indi += 1
                sm_crea.addline("->%s. %s" % (str(sm_indi), str(typeList[(sm_indp * 7) + (sm_indi - 1)])))
                sm_crea.submenu(sm_indi, "sm_type_%s_0" % str(typeList[(sm_indp * 7) + (sm_indi - 1)]))

            BuildMenu().setLine(sm_crea, server_var["sm_separ3"])

            if sm_indp + 1 < sm_page:
                sm_crea.addline("8. %s" % str(server_var["sm_action_next"]))
                sm_crea.submenu(8, "sm_type_%s" % (str(sm_indp + 1)))

            if sm_indp == 0:
                sm_crea.addline("9. %s" % str(server_var["sm_action_menu"]))
                sm_crea.submenu(9, "sm_menu")

            else:
                sm_crea.addline("9. %s" % str(server_var["sm_action_back"]))
                sm_crea.submenu(9, "sm_type_%s" % (str(sm_indp - 1)))

            sm_crea.addline("0. %s" % str(server_var["sm_action_exit"]))
            BuildMenu().setLine(sm_crea, server_var["sm_separ4"])
            sm_indp += 1


    def __sons(self, typeList, sonsType, sonsList):
        """
            Fonction: créer les pages du menu selon les sons répertoriés
        """

        sm_page = self.__page(len(sonsList))
        sm_indp = 0

        while sm_indp < sm_page:
            sm_indi = 0
            sm_item = self.__item(sm_indp, sm_page, len(sonsList))
            sm_name = "sm_type_%s_%s" % (str(sonsType), str(sm_indp))

            self.__sm_pars.add_section(sm_name)
            sm_crea = popuplib.create(sm_name)
            BuildMenu().setLine(sm_crea, server_var["sm_separ1"])
            sm_crea.addline("%s :    %s/%s" % (str(sonsType), str(sm_indp + 1), str(sm_page)))
            BuildMenu().setLine(sm_crea, server_var["sm_separ2"])

            while sm_indi < sm_item:
                sm_indi += 1
                self.__sm_pars.set(sm_name, str(sm_indi),str(sonsList[(sm_indp * 7) + (sm_indi - 1)]))
                sm_crea.addline("->%s. %s" % (str(sm_indi), str(sonsList[(sm_indp * 7) + (sm_indi - 1)])))

                if bool(SoundInfo.sm_stic):
                    sm_crea.submenu(sm_indi, "sm_type_%s_%s" % (str(sonsType), str(sm_indp)))

            BuildMenu().setLine(sm_crea, server_var["sm_separ3"])

            if sm_indp + 1 < sm_page:
                sm_crea.addline("8. %s" % str(server_var["sm_action_next"]))
                sm_crea.submenu(8, "sm_type_%s_%s" % (str(sonsType), str(sm_indp + 1)))

            if sm_indp == 0:
                if len(typeList) > 1:
                    sm_crea.addline("9. %s" % str(server_var["sm_action_type"]))
                    sm_crea.submenu(9, "sm_type_0")

                else:
                    sm_crea.addline("9. %s" % str(server_var["sm_action_menu"]))
                    sm_crea.submenu(9, "sm_menu")

            else:
                sm_crea.addline("9. %s" % str(server_var["sm_action_back"]))
                sm_crea.submenu(9, "sm_type_%s_%s" % (str(sonsType), str(sm_indp - 1)))


            sm_crea.addline("0. %s" % str(server_var["sm_action_exit"]))
            BuildMenu().setLine(sm_crea, server_var["sm_separ4"])
            sm_crea.menuselect = play
            sm_indp += 1


    def __team(self, typeList):
        """
            Fonction: créer les pages du menu selon représentant les teams
        """

        sm_team = popuplib.create("sm_team")
        BuildMenu().setLine(sm_team, server_var["sm_separ1"])
        sm_team.addline("%s" % str(server_var["sm_tittle_team"]))
        BuildMenu().setLine(sm_team, server_var["sm_separ2"])
        sm_team.addline("->1. %s" % str(server_var["sm_option_anti"]))
        sm_team.addline("->2. %s" % str(server_var["sm_option_tero"]))
        sm_team.addline("->3. %s" % str(server_var["sm_option_spec"]))
        BuildMenu().setLine(sm_team, server_var["sm_separ3"])
        sm_team.addline("9. %s" % str(server_var["sm_action_menu"]))
        sm_team.addline("0. %s" % str(server_var["sm_action_exit"]))
        BuildMenu().setLine(sm_team, server_var["sm_separ4"])

        if len(typeList) > 1:
            sm_team.submenu(1, "sm_type_0")
            sm_team.submenu(2, "sm_type_0")
            sm_team.submenu(3, "sm_type_0")

        else:
            sm_team.submenu(1, "sm_type_%s_0" % str(typeList[0]))
            sm_team.submenu(2, "sm_type_%s_0" % str(typeList[0]))
            sm_team.submenu(3, "sm_type_%s_0" % str(typeList[0]))

        sm_team.submenu(9, "sm_menu")
        sm_team.menuselect = team


    def getMenu(self):
        """
            Fonction: renvoie la configuration du menu
        """

        return self.__sm_pars


class SoundUser:
    """
        Classe privé

            -créer un menu 'indépendant' correspondant aux joueurs présent sur le serveur 
    """

    def __init__(self):
        """
            Fonction: créer les pages du menu selon la liste des joueurs
        """

        self.__sm_conf = ConfigParser.ConfigParser()
        self.__sm_pars = ConfigParser.ConfigParser()


    def suMake(self, userMenu, userList):
        """
            Fonction: créer les pages du menu selon la liste des joueurs
        """

        if int(userMenu):

            if self.__sm_conf.has_section(userMenu):
                self.__sm_conf.remove_section(userMenu)

            self.__sm_conf.add_section(userMenu)

            if self.__sm_pars.has_section(userMenu):
                self.__sm_pars.remove_section(userMenu)

            self.__sm_pars.add_section(userMenu)

            sm_indu = 0
            for sm_user in userList:

                sm_indu += 1
                self.__sm_conf.set(userMenu, str(sm_indu), str(es.getplayername(sm_user)))

            self.__user(userMenu, userList)
            popuplib.send("sm_user_%s_0" % str(userMenu), userMenu)


    def __page(self, itemCount):
        """
            Fonction: déterminer le nombre de pages
        """

        if itemCount < 8:
            return 1

        else:
            sm_page = itemCount / 6
            sm_rest = itemCount % 6

            if sm_rest > 1:
                sm_page += 1

            return sm_page


    def __item(self, itemIndex, itemPages, itemCount):
        """
            Fonction: déterminer le nombre de choix
        """

        if itemIndex + 1 < itemPages:
            return 6

        else:
            return itemCount - ((itemIndex) * 6)


    def __user(self, userMenu, userList):
        """
            Fonction: créer les pages du menu selon la liste des joueurs
        """

        sm_page = self.__page(len(userList))
        sm_indp = 0

        while sm_indp < sm_page:
            sm_indi = 0
            sm_item = self.__item(sm_indp, sm_page, len(userList))
            sm_name = "sm_user_%s_%s" % (str(userMenu), str(sm_indp))

            sm_crea = popuplib.create(sm_name)
            BuildMenu().setLine(sm_crea, server_var["sm_separ1"])
            sm_crea.addline("%s    %s/%s" % (str(server_var["sm_tittle_user"]), str(sm_indp + 1), str(sm_page)))
            BuildMenu().setLine(sm_crea, server_var["sm_separ2"])

            while sm_indi < sm_item:
                sm_indi += 1
                sm_crea.addline("->%s. %s" % (str(sm_indi), str(self.__sm_conf.get(userMenu, str((sm_indp * 6) + sm_indi)))))
                sm_crea.submenu(sm_indi, "sm_user_%s_%s" % (str(userMenu), str(sm_indp)))

            BuildMenu().setLine(sm_crea, server_var["sm_separ3"])

            if sm_indp + 1 < sm_page:
                sm_crea.addline("7. %s" % str(server_var["sm_action_vali"]))
                self.__sm_pars.set(userMenu, str(sm_indp), str(7))

                if len(SoundInfo.sm_list.getConf().sections()) > 1:
                    sm_crea.submenu(7, "sm_type_0")

                else:
                    sm_crea.submenu(7, "sm_type_%s_0" % str(SoundInfo.sm_list.getConf().sections()[0]))

                sm_crea.addline("8. %s" % str(server_var["sm_action_next"]))
                sm_crea.submenu(8, "sm_user_%s_%s" % (str(userMenu), str(sm_indp + 1)))

            else:
                sm_crea.addline("8. %s" % str(server_var["sm_action_vali"]))
                self.__sm_pars.set(userMenu, str(sm_indp),  str(8))

                if len(SoundInfo.sm_list.getConf().sections()) > 1:
                    sm_crea.submenu(8, "sm_type_0")

                else:
                    sm_crea.submenu(8, "sm_type_%s_0" % str(SoundInfo.sm_list.getConf().sections()[0]))

            if sm_indp == 0:
                sm_crea.addline("9. %s" % str(server_var["sm_action_menu"]))
                sm_crea.submenu(9, "sm_menu")

            else:
                sm_crea.addline("9. %s" % str(server_var["sm_action_back"]))
                sm_crea.submenu(9, "sm_user_%s_%s" % (str(userMenu), str(sm_indp - 1)))


            self.__sm_pars.set(userMenu, str(sm_name), str(sm_indi))
            sm_crea.addline("0. %s" % str(server_var["sm_action_exit"]))
            BuildMenu().setLine(sm_crea, server_var["sm_separ4"])
            sm_crea.menuselect = user
            sm_indp += 1


    def userConf(self):
        """
            Fonction: obtenir la configuration de la liste des joueurs
        """

        return self.__sm_conf


    def userMenu(self):
        """
            Fonction: obtenir la configuration du menu de l'utilisateur
        """

        return self.__sm_pars


class SoundStop:
    """
        classe privé.

            -créer une liste des sons qui ont été joué
    """

    def __init__(self):
        """
            Fonction: initialisation de la classe
        """

        self.__sm_stop = []

    def setSound(self, addSound):
        """
            Fonction: ajouter un sons a la liste
        """

        self.__sm_stop.append(addSound)

    def getSound(self):
        """
            Fonction: renvoie la liste des sons joué
        """

        return self.__sm_stop

    def delSound(self):
        """
            Fonction: éffacer la liste des sons joué
        """

        self.__sm_stop = []


class SoundInfo:
    """
        Classe privé.

            -encapsuler les variables utile au script
            -initialiser la configuration du script
            -faire télécharger les fichiers sons
    """

    sm_lang = es.ServerVar("sm_langue")
    sm_down = es.ServerVar("sm_dlfile")
    sm_stic = es.ServerVar("sm_sticky")
    sm_adms = es.ServerVar("sm_admins")

    sm_list = SoundList()
    sm_menu = SoundMenu()
    sm_user = SoundUser()
    sm_stop = SoundStop()
    sm_play = ConfigParser.ConfigParser()


    @staticmethod
    def setConfig():
        """
            Fonction: initialiser la configuration du script
        """

        es.ServerVar("sm_separ1")
        es.ServerVar("sm_separ2")
        es.ServerVar("sm_separ3")
        es.ServerVar("sm_separ4")

        es.ServerVar("sm_tittle_menu")
        es.ServerVar("sm_tittle_type")
        es.ServerVar("sm_tittle_user")
        es.ServerVar("sm_tittle_team")

        es.ServerVar("sm_option_type")
        es.ServerVar("sm_option_user")
        es.ServerVar("sm_option_team")
        es.ServerVar("sm_option_stop")
        es.ServerVar("sm_option_anti")
        es.ServerVar("sm_option_tero")
        es.ServerVar("sm_option_spec")

        es.ServerVar("sm_action_menu")
        es.ServerVar("sm_action_type")
        es.ServerVar("sm_action_vali")
        es.ServerVar("sm_action_back")
        es.ServerVar("sm_action_next")
        es.ServerVar("sm_action_exit")

        es.ServerVar(sm_info.name, sm_info.version, "version actuelle du script").makepublic()

        es.ForceServerCommand("es_mexec ../cfg/sound_menu/config.cfg")

        if os.path.isfile(sm_path + "language/" + SoundInfo.sm_lang + ".cfg"):
            es.ForceServerCommand("es_mexec ../cfg/sound_menu/language/" + SoundInfo.sm_lang + ".cfg")
            SoundInfo.sm_menu.smMake()

        if bool(SoundInfo.sm_down):
            for sm_down in SoundInfo.sm_list.getDown():
                es.stringtable("downloadables", sm_down)


#    Load    #
def load():
    SoundInfo().setConfig()


#    Config    #
def es_map_start(event_var):
    delpop()
    SoundInfo().setConfig()


def round_end(event_var):
    SoundInfo.sm_stop.delSound()


def player_disconnect(event_var):
    if event_var["networkid"] in str(SoundInfo.sm_adms).split(","):
        if SoundInfo.sm_user.userMenu().has_section(int(event_var["userid"])):
            for sm_dele in SoundInfo.sm_user.userMenu().options(int(event_var["userid"])):
                if popuplib.exists(sm_dele):
                    popuplib.delete(sm_dele)

        if SoundInfo.sm_play.has_section(int(event_var["userid"])):
            SoundInfo.sm_play.remove_section(int(event_var["userid"]))


#    Command    #
def es_client_command(event_var):
    if event_var["command"] == "!sound_menu":
        if es.getplayersteamid(event_var["userid"]) in str(SoundInfo.sm_adms).split(","):
            if popuplib.isqueued(popuplib.active(event_var["userid"])["name"], event_var["userid"]):
                popuplib.unsendname(popuplib.active(event_var["userid"])["name"], event_var["userid"])

            else:
                popuplib.send("sm_menu", event_var["userid"])


#    Choice    #
def menu(userid, choice, popupid):
    if choice < 5:
        if SoundInfo.sm_play.has_section(userid):
            SoundInfo.sm_play.remove_section(userid)

        SoundInfo.sm_play.add_section(userid)

        if choice == 1:
            for sm_user in playerlib.getUseridList("#human"):
                SoundInfo.sm_play.set(userid, str(sm_user), "player")

        elif choice == 2:
            SoundInfo.sm_user.suMake(userid, playerlib.getUseridList("#all"))

        elif choice == 4:
            stop()


def user(userid, choice, popupid):
    if int(SoundInfo.sm_user.userMenu().get(userid, str(popupid))) >= int(choice):
        if SoundInfo.sm_play.has_option(userid, str(es.getuserid(SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice)))))):
            SoundInfo.sm_play.remove_option(userid, str(es.getuserid(SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice))))))
            popuplib.find(popupid).modline(int(BuildMenu().sepNumb(server_var["sm_separ1"]) + BuildMenu().sepNumb(server_var["sm_separ2"])) + 1 + int(choice), "->%s. %s" % (str(choice), SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice)))))

        else:
            SoundInfo.sm_play.set(userid, str(es.getuserid(SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice))))), "player")
            popuplib.find(popupid).modline(int(BuildMenu().sepNumb(server_var["sm_separ1"]) + BuildMenu().sepNumb(server_var["sm_separ2"])) + 1 + int(choice), "->%s. *%s" % (str(choice), SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice)))))


def team(userid, choice, popupid):
    if choice == 1:
        for sm_user in playerlib.getUseridList("#human,#ct"):
            SoundInfo.sm_play.set(userid, sm_user, "player")

    elif choice == 2:
        for sm_user in playerlib.getUseridList("#human,#t"):
            SoundInfo.sm_play.set(userid, sm_user, "player")

    elif choice == 3:
        for sm_user in playerlib.getUseridList("#human,#spec"):
            SoundInfo.sm_play.set(userid, sm_user, "player")

        for sm_user in playerlib.getUseridList("#human,#un"):
            SoundInfo.sm_play.set(userid, sm_user, "player")


def stop():
    for sm_user in playerlib.getUseridList("#human"):
        for sm_stop in SoundInfo.sm_stop.getSound():
            es.stopsound(sm_user, sm_stop)

    SoundInfo.sm_stop.delSound()


def play(userid, choice, popupid):
    if SoundInfo.sm_menu.getMenu().has_option(str(popupid), str(choice)):
        if str(popupid).split("_")[2] in SoundInfo.sm_list.getConf().sections():
            for sm_user in SoundInfo.sm_play.options(int(userid)):
                es.playsound(int(sm_user), SoundInfo.sm_list.getConf().get(str(popupid).split("_")[2], SoundInfo.sm_menu.getMenu().get(str(popupid), str(choice))), 1)
                SoundInfo.sm_stop.setSound(SoundInfo.sm_list.getConf().get(str(popupid).split("_")[2], SoundInfo.sm_menu.getMenu().get(str(popupid), str(choice))))


#    Unload    #
def unload():
    delpop()


def delpop():
    if popuplib.exists("sm_menu"):
        popuplib.close("sm_menu", playerlib.getUseridList("#human"))
        popuplib.delete("sm_menu")

    for sm_dele in SoundInfo.sm_menu.getMenu().sections():
        if popuplib.exists(sm_dele):
            popuplib.close(sm_dele, playerlib.getUseridList("#human"))
            popuplib.delete(sm_dele)

    for sm_user in SoundInfo.sm_user.userMenu().sections():
        for sm_dele in SoundInfo.sm_user.userMenu().options(sm_user):
            if popuplib.exists(sm_dele):
                popuplib.close(sm_dele, playerlib.getUseridList("#human"))
                popuplib.delete(sm_dele)

#============================================================================================================================================#
